<?php
//************************************************************
//  PPRemote.php
//  Peppermint
//
//  Coded by Dr.Kameleon
//
//  Copyright (c) 2011-2014 InSili.co.
//  All rights reserved.
//************************************************************

//
// Example call:
//
// PPRemote.php uf "{t:'ftp',h:'4081.hostgator.com',u:'root',p:'123456'}" "public_html/some/path" "some/local/path"
//
 
// Parse arguments

$oper = $argv[1]; 				// upload/download file/folder (uf/ud/df/dd)
$conf = json_decode($argv[2]); 	// h:host, u:username, p:password, t:type
$dest = $argv[3];
$from = $argv[4];

if ($dest[0]!='/') $dest = "/$dest";

echo "OP: $oper, FROM: $from, TO: $dest\n";
print_r($conf);

/************************************
 UPLOAD FILE
 ************************************/
if ($oper=="uf")
{

	if ($conf->t=="ftp")
	{
		try {
			include 'phpseclib/Ftp.php';
			$ftp = new Net_FTP;

			$ftp->connect($conf->h);
			$ftp->login($conf->u, $conf->p);

			$ftp->put($dest, $from, FTP_BINARY);
		}
		catch (FtpException $e) {
			echo 'FTP :: ', $e->getMessage();
		}
	}
	elseif ($conf->t=="sftp")
	{
		try {
			include 'phpseclib/Net/SFTP.php';
        
            $sftp = new Net_SFTP($conf->h);
            if (!$sftp->login($conf->u, $conf->p)) 
            {
                exit("FTP :: Login failed with credentials (u: $username, p: $password)");
            }
            
			$sftp->put($dest, $from, NET_SFTP_LOCAL_FILE);
		}
		catch (Exception $e)
		{
			echo "SFTP :: ". $e->getMessage();
		}
	}
}

/************************************
 UPLOAD DIRECTORY
 ************************************/
elseif ($oper=="ud")
{
	if ($conf->t=="ftp")
	{
		try {
			include 'phpseclib/Ftp.php';
			$ftp = new Net_FTP;

			$ftp->connect($conf->h);
			$ftp->login($conf->u, $conf->p);

			$ftp->mkDirRecursive($dest);
		}
		catch (FtpException $e) {
			echo 'FTP :: ', $e->getMessage();
		}
	}
	elseif ($conf->t=="sftp")
	{
		try {
			include 'phpseclib/Net/SFTP.php';
        
            $sftp = new Net_SFTP($conf->h);
            if (!$sftp->login($conf->u, $conf->p)) 
            {
                exit("FTP :: Login failed with credentials (u: $username, p: $password)");
            }
            
			$sftp->mkdir($dest,-1,true);
		}
		catch (Exception $e)
		{
			echo "SFTP :: ". $e->getMessage();
		}
	}
}

/************************************
 DOWNLOAD FILE
 ************************************/
elseif ($oper=="df")
{

	if ($conf->t=="ftp")
	{
		try {
			include 'phpseclib/Ftp.php';
			$ftp = new Net_FTP;

			$ftp->connect($conf->h);
			$ftp->login($conf->u, $conf->p);

			$ftp->get($dest, $from, FTP_BINARY);
		}
		catch (FtpException $e) {
			echo 'FTP :: ', $e->getMessage();
		}
	}
	elseif ($conf->t=="sftp")
	{
		try {
			include 'phpseclib/Net/SFTP.php';
        
            $sftp = new Net_SFTP($conf->h);
            if (!$sftp->login($conf->u, $conf->p)) 
            {
                exit("FTP :: Login failed with credentials (u: $username, p: $password)");
            }
            
			$sftp->get($from, $dest);
		}
		catch (Exception $e)
		{
			echo "SFTP :: ". $e->getMessage();
		}
	}
}

/************************************
 DOWNLOAD FOLDER
 ************************************/
elseif ($oper=="dd")
{
	mkdir($dest);
}
	
?>